// Code generated by gobind. DO NOT EDIT.

// Java class org.ethereum.geth.WhisperClient is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=org.ethereum github.com/ethereum/go-ethereum/mobile
package org.ethereum.geth;

import go.Seq;

/**
 * WhisperClient provides access to the Ethereum APIs.
 */
public final class WhisperClient implements Seq.Proxy {
	static { Geth.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewWhisperClient connects a client to the given URL.
	 */
	public WhisperClient(String rawurl) {
		this.refnum = __NewWhisperClient(rawurl);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewWhisperClient(String rawurl);
	
	WhisperClient(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * AddPrivateKey stored the key pair, and returns its ID.
	 */
	public native String addPrivateKey(Context ctx, byte[] key) throws Exception;
	/**
	 * AddSymmetricKey stores the key, and returns its identifier.
	 */
	public native String addSymmetricKey(Context ctx, byte[] key) throws Exception;
	/**
	 * DeleteKeyPair delete the specifies key.
	 */
	public native String deleteKeyPair(Context ctx, String id) throws Exception;
	/**
	 * DeleteMessageFilter removes the filter associated with the given id.
	 */
	public native void deleteMessageFilter(Context ctx, String id) throws Exception;
	/**
	 * DeleteSymmetricKey deletes the symmetric key associated with the given identifier.
	 */
	public native void deleteSymmetricKey(Context ctx, String id) throws Exception;
	/**
	 * GenerateSymmetricKeyFromPassword generates the key from password, stores it, and returns its identifier.
	 */
	public native String generateSymmetricKeyFromPassword(Context ctx, String passwd) throws Exception;
	/**
	 * GetFilterMessages retrieves all messages that are received between the last call to
	this function and match the criteria that where given when the filter was created.
	 */
	public native Messages getFilterMessages(Context ctx, String id) throws Exception;
	/**
	 * Info returns diagnostic information about the whisper node.
	 */
	public native Info getInfo(Context ctx) throws Exception;
	/**
	 * GetPrivateKey return the private key for a key ID.
	 */
	public native byte[] getPrivateKey(Context ctx, String id) throws Exception;
	/**
	 * GetPublicKey return the public key for a key ID.
	 */
	public native byte[] getPublicKey(Context ctx, String id) throws Exception;
	/**
	 * GetSymmetricKey returns the symmetric key associated with the given identifier.
	 */
	public native byte[] getSymmetricKey(Context ctx, String id) throws Exception;
	/**
	 * GetVersion returns the Whisper sub-protocol version.
	 */
	public native String getVersion(Context ctx) throws Exception;
	/**
	 * HasKeyPair returns an indication if the node has a private key or
	key pair matching the given ID.
	 */
	public native boolean hasKeyPair(Context ctx, String id) throws Exception;
	/**
	 * HasSymmetricKey returns an indication if the key associated with the given id is stored in the node.
	 */
	public native boolean hasSymmetricKey(Context ctx, String id) throws Exception;
	/**
	 * Marks specific peer trusted, which will allow it to send historic (expired) messages.
	Note This function is not adding new nodes, the node needs to exists as a peer.
	 */
	public native void markTrustedPeer(Context ctx, String enode) throws Exception;
	/**
	 * NewKeyPair generates a new public and private key pair for message decryption and encryption.
	It returns an identifier that can be used to refer to the key.
	 */
	public native String newKeyPair(Context ctx) throws Exception;
	/**
	 * NewMessageFilter creates a filter within the node. This filter can be used to poll
	for new messages (see FilterMessages) that satisfy the given criteria. A filter can
	timeout when it was polled for in whisper.filterTimeout.
	 */
	public native String newMessageFilter(Context ctx, Criteria criteria) throws Exception;
	/**
	 * NewSymmetricKey generates a random symmetric key and returns its identifier.
	Can be used encrypting and decrypting messages where the key is known to both parties.
	 */
	public native String newSymmetricKey(Context ctx) throws Exception;
	/**
	 * Post a message onto the network.
	 */
	public native String post(Context ctx, NewMessage message) throws Exception;
	/**
	 * SetMaxMessageSize sets the maximal message size allowed by this node. Incoming
	and outgoing messages with a larger size will be rejected. Whisper message size
	can never exceed the limit imposed by the underlying P2P protocol (10 Mb).
	 */
	public native void setMaxMessageSize(Context ctx, int size) throws Exception;
	/**
	 * SetMinimumPoW (experimental) sets the minimal PoW required by this node.
	This experimental function was introduced for the future dynamic adjustment of
	PoW requirement. If the node is overwhelmed with messages, it should raise the
	PoW requirement and notify the peers. The new value should be set relative to
	the old value (e.g. double). The old value could be obtained via shh_info call.
	 */
	public native void setMinimumPoW(Context ctx, double pow) throws Exception;
	/**
	 * SubscribeMessages subscribes to messages that match the given criteria. This method
	is only supported on bi-directional connections such as websockets and IPC.
	NewMessageFilter uses polling and is supported over HTTP.
	 */
	public native Subscription subscribeMessages(Context ctx, Criteria criteria, NewMessageHandler handler, long buffer) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof WhisperClient)) {
		    return false;
		}
		WhisperClient that = (WhisperClient)o;
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("WhisperClient").append("{");
		return b.append("}").toString();
	}
}

